/*******************************************************************************
*    IM-Daemon                                                                 *
*    Copyright (C) 2012-averyfarwaydate Luca Bertoncello                       *
*    Hartigstrasse, 12 - 01127 Dresden Deutschland                             *
*    E-Mail: lucabert@lucabert.de, lucabert@lucabert.com                       *
*    http://www.lucabert.de/  http://www.lucabert.com/                         *
*                                                                              *
*    This program is free software; you can redistribute it and/or modify      *
*    it under the terms of the GNU General Public License as published by      *
*    the Free Software Foundation; version 2 of the License.                   *
*                                                                              *
*    This program is distributed in the hope that it will be useful,           *
*    but WITHOUT ANY WARRANTY; without even the implied warranty of            *
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
*    GNU General Public License for more details.                              *
*                                                                              *
*    You should have received a copy of the GNU General Public License         *
*    along with this program; if not, write to the Free Software               *
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA *
*******************************************************************************/

#ifndef OPTIONS_H_
#define OPTIONS_H_

enum TYPE {INT, STRING, BOOL};

// Struktur für eine Option vom Kommandozeile
struct option
{
  char *optNameLong;     // Name der Option
  char optNameShort;     // Name der Option (abgekürzt)
  enum TYPE type;        // Typ der Option (siehe enum TYPE)
  void *value;           // Gelesener Wert
  void *defValue;        // Defaultwert
};

// Struktur für alle Optionen vom Kommandozeile
struct options
{
  int nOptions;           // Anzahl der möglichen Optionen
  struct option* opt;     // Array mit Struktur der Optionen
  char *invalidOptionMsg; // Text für die ungültige angegebene Option
};

/**
 * Liest die Optionen vom Kommandozeile
 *
 * @param int            argc  Anzahl der Parameter im Kommandozeile
 * @param char*          argv  Die Parameter im Kommandozeile
 * @param struct options opts  Die Beschreibung der möglichen Parameter
 */
int getOptions(int argc, char* argv[], struct options opts);

#endif /* OPTIONS_H_ */
